--------------------
------- MoMo -------
--------------------

local C_Emote = CreateFrame("Frame")

--localization
local locale = GetLocale()

local L_CRITTER = "Critter"
local L_AlreadyLoved = "Already loved"
local L_NeedsLove = "Needs some love"
local L_AlreadyKilled = "Already killed"
local L_NeedtoKill = "Must be killed"

if (locale == "deDE") then
	L_CRITTER = "Tier"
	L_AlreadyLoved = "Wurde bereits geliebt"
	L_NeedsLove = "Braucht etwas Liebe"
	L_AlreadyKilled = "Bereits gettet"
	L_NeedtoKill = "Muss gettet werden"
end
--------------------------------------------------------
local C_Emote_ACHID = {
	LoveCritters = 1206,
	LoveCritters2 = 2557,
	LoveCritters3 = 5548,
	PestControl = 2556,	
};

local function isCriteria(achID, name)
  local n, t, complete
  for i=1,GetAchievementNumCriteria(achID) do
    n, t, complete = GetAchievementCriteriaInfo(achID, i)
    if (n == name) then  return true, complete;  end
  end
end

local CritterAch = {
  LoveCritters = { "Critter_loved", L_AlreadyLoved, L_NeedsLove },
  LoveCritters2 = { "Critter_loved", L_AlreadyLoved, L_NeedsLove },
LoveCritters3 = { "Critter_loved", L_AlreadyLoved, L_NeedsLove },
  PestControl = { "Critter_killed", L_AlreadyKilled, L_NeedtoKill },
};

local function CritterCheck(ach, name)
  local id = C_Emote_ACHID[ach]
  if (select(4, GetAchievementInfo(id))) then
    CritterAch[ach] = nil;
    return;
  end
  local isCrit, complete = isCriteria(id, name)
  if (isCrit) then
    return id, complete and CritterAch[ach][2] or CritterAch[ach][3], complete
  end
end
--------------------------------------------------------
C_Emote:RegisterEvent("PLAYER_TARGET_CHANGED")

C_Emote:SetScript("OnEvent", function(self, event, ...)
	if( event == "PLAYER_TARGET_CHANGED" ) then
		local name = UnitName("target")
		local creatureType = UnitCreatureType("target")
		if creatureType == L_CRITTER then
			for key,tab in pairs(CritterAch) do
				local id, text, complete = CritterCheck(key, name)
				if (text) then
					if (complete) then
						UIErrorsFrame:AddMessage(text, 0, 1, 0, 77, 3);
						--print(text)
					else
						if id == 2556 then
							PlaySoundFile([[Interface\AddOns\MoMo_Critter_Emote\Media\finishim.mp3]])
							UIErrorsFrame:AddMessage(text, 1, 0, 0, 77, 4);
						else
							DoEmote("LOVE");
						end
					end
				end
			end
		end		
	end
end)


SLASH_MoMo_Critter_Emote1, SLASH_MoMo_Critter_Emote2 = '/ce', '/critters';
function SlashCmdList.MoMo_Critter_Emote(msg, editbox)
	InterfaceOptionsFrame_OpenToCategory("Critter Emote");
end

