﻿-- Variables and Tables
local BZ = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local _
local ACH1 = select(2, GetAchievementInfo(1206))
local ACH2 = select(2, GetAchievementInfo(2557))
local ACH3 = select(2, GetAchievementInfo(2556))
local ACH = {
	Entry1 = { ACH1, 1206 },
	Entry2 = { ACH2, 2557 },
	Entry3 = { ACH3, 2556 },
}
local last
local locations = {}
local n, t, complete
local globalcount = 1
	
local CritterZones = {
	[9299] = BZ["Dragonblight"]..", "..BZ["Borean Tundra"], -- Arktishase
	[9300] = BZ["Borean Tundra"], -- Boreanisches Murmeltier
	[9301] = BZ["Howling Fjord"], -- Fjordpinguin
	[9302] = BZ["Howling Fjord"], -- Fjordtruthahn
	[9303] = BZ["Icecrown"], -- Gletscherpinguin
	[9304] = BZ["Grizzly Hills"], -- Grizzlyeichhörnchen
	[9305] = BZ["Swamp of Sorrows"]..", "..BZ["Zul'Drak"], -- Titanische Kröte
	[9306] = BZ["Searing Gorge"]..", "..BZ["Burning Steppes"], -- Lavakrebs
	[9307] = BZ["Grizzly Hills"], -- Bergstinktier
	[9308] = BZ["Howling Fjord"], -- Ganovenfrosch
	[9309] = BZ["Sholazar Basin"], -- Sholazarmadenhacker
	[9310] = BZ["Borean Tundra"], -- Tundrapinguin
	[9311] = BZ["Durotar"], -- Hase
	[3753] = BZ["Durotar"], -- Hase DUPLI
	[9358] = BZ["Durotar"]..", "..BZ["The Barrens"]..", "..BZ["Hellfire Peninsula"], -- Otter
	[9818] = BZ["Dalaran"]..", "..BZ["Stormwind City"]..", "..BZ["Ashenvale"], -- Eichhörnchen
	[3615] = BZ["Dalaran"]..", "..BZ["Stormwind City"]..", "..BZ["Ashenvale"], -- Eichhörnchen DUPLI
	[9359] = BZ["The Nexus"], -- Kristallspinne
	[9360] = BZ["Howling Fjord"], -- Verschlingende Made
	[9361] = BZ["Searing Gorge"]..", "..BZ["Burning Steppes"], -- Feuerkäfer
	[9362] = BZ["Howling Fjord"], -- Fjordratte
	[9363] = BZ["Halls of Stone"], -- Goldkäfer
	[9364] = BZ["Naxxramas"]..", "..BZ["Ghostlands"], -- Larve
	[9365] = BZ["Naxxramas"]..", "..BZ["Ghostlands"], -- Made
	[9366] = BZ["Swamp of Sorrows"], -- Mokassin
	[9367] = BZ["Westfall"]..", "..BZ["Grizzly Hills"], -- Maus
	[9368] = BZ["Stormwind City"]..", "..BZ["Tirisfal Glades"]..", "..BZ["Dalaran"], -- Ratte
	[9369] = BZ["Ahn'kahet: The Old Kingdom"]..", "..BZ["Azjol-Nerub"], -- Schabe
	[9370] = BZ["Hellfire Peninsula"], -- Skorpion
	[9371] = BZ["Gundrak"]..", "..BZ["Westfall"], -- Natter
	[9372] = BZ["Drak'Tharon Keep"], -- Spinne
	[9373] = BZ["Dalaran"], -- Ratte der Schattenseite
	[9374] = BZ["Zul'Drak"], -- Ratte von Zul'Drak
	[3739] = BZ["Borean Tundra"], -- Dampffrosch
	[3741] = BZ["Borean Tundra"], -- Boreanischer Frosch
	[3744] = BZ["Eversong Woods"]..", "..BZ["Elwynn Forest"], -- Katze
	[3745] = BZ["Westfall"]..", "..BZ["Tirisfal Glades"]..", "..BZ["Elwynn Forest"], -- Huhn
	[3746] = BZ["Elwynn Forest"]..", "..BZ["Hillsbrad Foothills"], -- Kuh
	[3747] = BZ["Borean Tundra"]..", "..BZ["Howling Fjord"], -- Krebs
	[3748] = BZ["Moonglade"]..", "..BZ["Elwynn Forest"]..", "..BZ["Ashenvale"], -- Reh
	[3749] = BZ["Shattrath City"], -- Zibbe
	[3750] = BZ["Elwynn Forest"]..", "..BZ["Grizzly Hills"], -- Rehkitz
	[3751] = BZ["Gundrak"]..", "..BZ["Zangarmarsh"], -- Frosch
	[3752] = BZ["The Barrens"], -- Gazelle
	[3754] = BZ["Un'Goro Crater"], -- Papagei
	[3755] = BZ["Dalaran"]..", "..BZ["Elwynn Forest"]..", "..BZ["Tirisfal Glades"], -- Kaninchen
	[3756] = BZ["Loch Modan"]..", "..BZ["Wetlands"], -- Widder
	[3757] = BZ["Elwynn Forest"], -- Schaf
	[3758] = BZ["Howling Fjord"], -- Stinktier
	[3759] = BZ["Durotar"], -- Schwein
	[3760] = BZ["Darnassus"]..", "..BZ["Swamp of Sorrows"], -- Kröte
	[3761] = BZ["Westfall"]..", "..BZ["The Barrens"], -- Präriehund
}
----------------------
	
-- TODO
-- Refresh Critter List after kill/love
	
local frame = CreateFrame("ScrollFrame", nil, InterfaceOptionsFramePanelContainer)
frame.name = "Critter Emote"
frame:Hide()

frame:SetScript("OnShow", function(self)
	local title, subtitle = LibStub("tekKonfig-Heading").new(self, "Critter Emote", "Small guide to find all critters.")

	local group = LibStub("tekKonfig-Group").new(self)
	group:SetPoint("TOP", subtitle, "BOTTOM", 0, -8)
	group:SetPoint("BOTTOMLEFT", 16, 16)
	group:SetPoint("BOTTOMRIGHT", -16, 16)

	local GAP = 5
	local scroll = CreateFrame("ScrollFrame", nil, group)
	scroll:SetPoint("TOPRIGHT", -GAP, -GAP)
	scroll:SetPoint("BOTTOMLEFT", GAP, GAP)

	local frame = CreateFrame("Frame", nil, scroll)
	scroll:SetScrollChild(frame)
	frame:SetPoint("TOP")
	frame:SetPoint("LEFT")
	frame:SetPoint("RIGHT")
	frame:SetHeight(1000)

	local scrollbar, upbutt, downbutt = LibStub("tekKonfig-Scroll").new(group, 6)
	scrollbar:SetMinMaxValues(0,700) --550
	scrollbar:SetValue(0)

	local f = scrollbar:GetScript("OnValueChanged")
	scrollbar:SetScript("OnValueChanged", function(self, value, ...)
		scroll:SetVerticalScroll(value)
		frame:SetPoint("TOP", 0, value)
		return f(self, value, ...)
	end)

	local offset = 0
	scroll:UpdateScrollChildRect()
	scroll:EnableMouseWheel(true)
	scroll:SetScript("OnMouseWheel", function(self, val) scrollbar:SetValue(scrollbar:GetValue() - val*50) 	  end)
	
	for o, v in pairs(ACH) do
		locations[globalcount] = { ACH[o][1], nil, "" }
		globalcount = globalcount + 1
		for i=1,GetAchievementNumCriteria(ACH[o][2]) do
			n, _, complete, _, _, _, _, _, _, cID = GetAchievementCriteriaInfo(ACH[o][2], i)
			--print("name: "..n.." - ID: "..cID) --## SHOW CRITERIA AND ID
			-- ##locations[globalcount] = {n , complete} -- original without zones
			locations[globalcount] = {n, complete, CritterZones[cID] or ""}-- New with zones

			globalcount = globalcount + 1
		end
	end
		
	for i,CL in pairs(locations) do
		local font	
		if locations[i][1] == ACH1 or locations[i][1] == ACH2 or locations[i][1] == ACH3 then
			font = "GameFontNormalLarge"
		elseif locations[i][2] == false then
			font = "GameFontHighlight"
		else
			font = "GameFontDisable"
		end
		
		local fs = frame:CreateFontString(nil, "ARTWORK", font)
			fs:SetPoint("TOP", last or frame, last and "BOTTOM" or "TOP", 0, last and -4 or 0)
			
			if locations[i][1] == ACH1 or locations[i][1] == ACH2 or locations[i][1] == ACH3 then
				fs:SetText(locations[i][1])
			else
				fs:SetText(locations[i][1].." > "..locations[i][3])
			end

		last = fs
	end
	
	self:SetScript("OnShow", nil)

end)

InterfaceOptions_AddCategory(frame)

